Index: channels/chan_sip.c
===================================================================
--- channels/chan_sip.c	(revision 328417)
+++ channels/chan_sip.c	(arbetskopia)
@@ -1512,6 +1512,7 @@
 static void make_our_tag(char *tagbuf, size_t len);
 static int add_header(struct sip_request *req, const char *var, const char *value);
 static int add_header_max_forwards(struct sip_pvt *dialog, struct sip_request *req);
+static void add_diversion_header(struct sip_request *req, struct sip_pvt *pvt);
 static int add_content(struct sip_request *req, const char *line);
 static int finalize_content(struct sip_request *req);
 static int add_text(struct sip_request *req, const char *text);
@@ -10348,6 +10349,11 @@
 		add_cc_call_info_to_response(p, &resp);
 	}
 
+	/* If we are sending a 302 Redirect we can add a diversion header if the redirect information is set */
+	if (!strncmp(msg, "302", 3)) {
+		add_diversion_header(&resp, p);
+	}
+
 	/* If we are cancelling an incoming invite for some reason, add information
 		about the reason why we are doing this in clear text */
 	if (p->method == SIP_INVITE && msg[0] != '1') {
